import parser._
import microc._

val pref = ProgFun.parse(
  """
fun troca(a, b)
  let tmp = *a in
    *a := *b;
    *b := tmp
  end
end

let x = 1, y = 2 in
  troca(&x, &y);
  x - y
end + let a = 3, b = 4 in
  a + b
end
  """)
eval(pref)
val psoma = ProgFun.parse("2 + 3 * 5")
eval(psoma)
val pfun = ProgFun.parse(
  """
fun f(a, b, c)
  a + b * c
end

f(2, 3, 5)
  """)
eval(pfun)

val pfunat = ProgFun.parse(
  """
fun f(a, b, c)
  a := a + b * c;
  a
end
f(2, 3, 5)
  """)
eval(pfunat)

val pend = ProgFun.parse(
  """
    *5 := 2 + 2;
    *5
  """)
eval(pend)

val pvet = ProgFun.parse(
  """
fun soma(vet, len)
  if len < 1 then
    0
  else
    *vet + soma(vet + 1, len - 1)
  end
end

let vet = 1000 in
  *1000 := 2;
  *(1000 + 1) := 4;
  *(1000 + 2) := 6;
  soma(vet, 3)
end
  """)
eval(pvet)